Attribute VB_Name = "Module1"
' Dieser Source stammt von http://www.activevb.de
' und kann frei verwendet werden. Fr eventuelle Schden
' wird nicht gehaftet.
'
' Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
' Ansonsten viel Spa und Erfolg mit diesem Source!

Option Explicit

Private Declare Function SetWindowLong Lib "user32" Alias _
        "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As _
        Long, ByVal dwNewLong As Long) As Long
        
Private Declare Function CallWindowProc Lib "user32" Alias _
        "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal _
        hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, _
        ByVal lParam As Long) As Long
        
Private Declare Function SetClipboardViewer Lib "user32" _
        (ByVal hWnd As Long) As Long
        
Private Declare Function ChangeClipboardChain Lib "user32" _
        (ByVal hWnd As Long, ByVal hWndNext As Long) As Long
        
Private Declare Function SendMessage Lib "user32" Alias _
        "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As _
        Long, ByVal wParam As Long, lParam As Long) As Long

Const GWL_WNDPROC = (-4&)
Const WM_SYSCOMMAND = &H112

Const WM_DRAWCLIPBOARD = &H308
Const WM_CHANGECBCHAIN = &H30D

Dim PrevWndProc&, hView&

Public Sub Init(hWnd&)
    PrevWndProc = SetWindowLong(hWnd, GWL_WNDPROC, _
                                AddressOf WndProc)
    hView = SetClipboardViewer(hWnd)
End Sub

Public Sub Terminate(hWnd&)
  Call ChangeClipboardChain(hWnd, hView)
  Call SetWindowLong(hWnd, GWL_WNDPROC, PrevWndProc)
End Sub

Private Function WndProc(ByVal hWnd&, ByVal Msg&, ByVal _
                         wParam&, ByVal lParam&) As Long
  
    Select Case Msg
      Case WM_CHANGECBCHAIN:
                             If wParam = hView Then
                               hView = lParam
                             ElseIf (hView <> 0) Then
                               Call SendMessage(hView, Msg, _
                                                wParam, lParam)
                             End If
        
      Case WM_DRAWCLIPBOARD
           Beep
           
           If Clipboard.GetFormat(vbCFText) Then
             Form1.Text1.Text = Left$(Clipboard.GetText, 32767)
           End If
           
           If Clipboard.GetFormat(vbCFBitmap) Then
             Form1.Picture1.Picture = _
                   Clipboard.GetData(vbCFBitmap)
           End If
        
           If (hView <> 0) Then
             Call SendMessage(hView, Msg, wParam, lParam)
           End If
    End Select

    WndProc = CallWindowProc(PrevWndProc, hWnd, Msg, _
                             wParam, lParam)
End Function
